"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .integrationtype import IntegrationType
from .transactionstatus import TransactionStatus
from codat_sync_for_expenses.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing_extensions import Annotated, NotRequired, TypedDict


class SchemaTransactionTypedDict(TypedDict):
    integration_type: NotRequired[Nullable[IntegrationType]]
    r"""Type of transaction that has been processed e.g. Expense or Bank Feed."""
    message: NotRequired[Nullable[str]]
    r"""Metadata such as validation errors or the resulting record created in the accounting software."""
    status: NotRequired[Nullable[TransactionStatus]]
    r"""Status of the transaction."""
    transaction_id: NotRequired[Nullable[str]]
    r"""Your unique idenfier of the transaction."""


class SchemaTransaction(BaseModel):
    integration_type: Annotated[
        OptionalNullable[IntegrationType], pydantic.Field(alias="integrationType")
    ] = IntegrationType.EXPENSES
    r"""Type of transaction that has been processed e.g. Expense or Bank Feed."""

    message: OptionalNullable[str] = UNSET
    r"""Metadata such as validation errors or the resulting record created in the accounting software."""

    status: OptionalNullable[TransactionStatus] = UNSET
    r"""Status of the transaction."""

    transaction_id: Annotated[
        OptionalNullable[str], pydantic.Field(alias="transactionId")
    ] = UNSET
    r"""Your unique idenfier of the transaction."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["integrationType", "message", "status", "transactionId"]
        nullable_fields = ["integrationType", "message", "status", "transactionId"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
